<?php
include 'functions.php';

/////////////////////////
// Variable definition //
/////////////////////////
$ini_array = parse_ini_file("config.ini");
$auditedDomains_arr = explode(',', $ini_array['auditedDomains']);

if ((strtoupper($chk_username) != strtoupper($user_input)) || ($chk_sess_id != $sessid_input)){
        header('Location: ./');
        exit;
}
$sec_fil = "./@.security"; // Configuration file with the groups authorized to login on the password database
$sec_arr = file($sec_fil); // Read the security file and put each line in an array
natsort($sec_arr); //sort the array
$sec_arr_short = array();
foreach ($sec_arr as $sec_arr_fullcn)
{
        $sec_arr_shortcn = explode(",",$sec_arr_fullcn);
        array_push($sec_arr_short, $sec_arr_shortcn[0]);
}
$url = "http" . ((!empty($_SERVER['HTTPS'])) ? "s" : "") . "://".$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI']; // Current url
// Get the current logged in username and his group membership
session_start();
$username = $_SESSION['username'];

if (empty($username)) {
        header('Location: ./');
        exit;
}
$groupArray = $_SESSION['group_arr'];
$sess_id = $_SESSION['sess_id'];

//authentication cookie check
$cookie_value = $_COOKIE[$sess_id];
if (!is_string($cookie_value)) return null;
//$r='';
//for ($a=0; $a<strlen($cookie_value); $a+=2) { $r.=chr(hexdec($cookie_value{$a}.$cookie_value{($a+1)})); }
//$cookie_dec = decrypt($cookie_value, $sess_id);
$cookie_dec = cryptoJsAesDecrypt($sess_id, base64_decode($cookie_value));

$auth_param = trim($cookie_dec);
$cookie_param_arr = explode(",",$auth_param);
$cookie_user = $cookie_param_arr[0];
$cookie_date = $cookie_param_arr[1];
$cookie_sessid = $cookie_param_arr[2];
$cookie_diff = time() - $cookie_date;

// Parse the groups in the security file
foreach ($sec_arr as $secgroup) {
        $sec_arr_trim[] = trim($secgroup);
}
$acl = array();
$acl = array_intersect($groupArray[0]["memberof"], $sec_arr_trim);
$session_timeout = 3600;
auth_check($acl, $cookie_user, $cookie_sessid, $cookie_diff, $session_timeout);

foreach ($acl as $group_cn) {
        $global_group_cn1 = explode(",",$group_cn);
        $global_group_cn[] = $global_group_cn1[0];
}
$groupIDStr = implode(',',$global_group_cn);

strtolower($username);
?>

<!DOCTYPE html>
<html>
<head>
<title>Active Directory Audit</title>
<meta name='author' content='Nicolas HAHANG' />
<meta name='copyright' content='2014 - Nicolas HAHANG' />
<meta http-equiv="refresh" content="<?php echo $session_timeout ?>" >
<meta charset="UTF-8">

<link href="css/bootstrap.min.css" rel="stylesheet" />
<link href="css/font-awesome.min.css" rel="stylesheet" />
<link href="css/daterangepicker-bs3.css" rel="stylesheet" />
<link href="css/grid.css" rel="stylesheet" />
<link href="css/dataTables.scroller.min.css" rel="stylesheet" />

<script type="text/javascript" src="js/jquery.js"></script>
<script type="text/javascript" src="js/moment.min.js"></script>
<script type="text/javascript" src="js/daterangepicker.js"></script>
<script type="text/javascript" src="js/jquery.dataTables.min.js"> </script>
<script type="text/javascript" src="js/dataTables.scroller.min.js"> </script>
<script type="text/javascript" src="js/bootstrap.min.js"> </script>
<script type="text/javascript" src="js/table2CSV.js"></script>
<script type="text/javascript" src='js/aes.js'></script>
<script type="text/javascript" src='js/crypto-js.js'></script>

<script type="text/javascript">
var CryptoJSAesJson = {
	stringify: function (cipherParams) {
	    var j = {ct: cipherParams.ciphertext.toString(CryptoJS.enc.Base64)};
	    if (cipherParams.iv) j.iv = cipherParams.iv.toString();
	    if (cipherParams.salt) j.s = cipherParams.salt.toString();
		    return JSON.stringify(j);
	},
	parse: function (jsonStr) {
	    var j = JSON.parse(jsonStr);
	    var cipherParams = CryptoJS.lib.CipherParams.create({ciphertext: CryptoJS.enc.Base64.parse(j.ct)});
	    if (j.iv) cipherParams.iv = CryptoJS.enc.Hex.parse(j.iv)
	    if (j.s) cipherParams.salt = CryptoJS.enc.Hex.parse(j.s)
	    return cipherParams;
	}
}

$(document).ready(function() {
	$('#daterange').daterangepicker(
		{
			ranges: {
				'Today': [new Date(), new Date()],
				'Yesterday': [moment().subtract('days', 1), moment().subtract('days', 1)],
				'Last 5 Days': [moment().subtract('days', 4), new Date()],
			},
			opens: 'left',
			format: 'YYYY-MM-DD',
			dateLimit: { days: 5 },
			startDate: new Date(),
			endDate: new Date()			
		}, 
		function(start, end) {
			$('#daterange span').html(start.format('MMM D, YYYY') + ' - ' + end.format('MMM D, YYYY'));
		}
	);
	$('#daterange').on('apply', function(ev, picker) {
		daterange = '\'' + picker.startDate.format('YYYY-MM-DD') + ' 00:00:00\' AND \'' + picker.endDate.format('YYYY-MM-DD') + ' 23:59:59\'' ;	
		BuildMainPwdTable(daterange,username,'');
	});
});
	
var audit_section_clicked = "all";

// FUNCTION TO REFRESH DATATABLE
$.fn.dataTableExt.oApi.fnReloadAjax = function ( oSettings, sNewSource, fnCallback, bStandingRedraw )
{
    if ( sNewSource !== undefined && sNewSource !== null ) {
        oSettings.sAjaxSource = sNewSource;
    }
 
    // Server-side processing should just call fnDraw
    if ( oSettings.oFeatures.bServerSide ) {
        this.fnDraw();
        return;
    }
 
    this.oApi._fnProcessingDisplay( oSettings, true );
    var that = this;
    var iStart = oSettings._iDisplayStart;
    var aData = [];
 
    this.oApi._fnServerParams( oSettings, aData );
 
    oSettings.fnServerData.call( oSettings.oInstance, oSettings.sAjaxSource, aData, function(json) {
        /* Clear the old information from the table */
        that.oApi._fnClearTable( oSettings );
 
        /* Got the data - add it to the table */
        var aData =  (oSettings.sAjaxDataProp !== "") ?
            that.oApi._fnGetObjectDataFn( oSettings.sAjaxDataProp )( json ) : json;
 
        for ( var i=0 ; i<aData.length ; i++ )
        {
            that.oApi._fnAddData( oSettings, aData[i] );
        }
         
        oSettings.aiDisplay = oSettings.aiDisplayMaster.slice();
 
        that.fnDraw();
 
        if ( bStandingRedraw === true )
        {
            oSettings._iDisplayStart = iStart;
            that.oApi._fnCalculateEnd( oSettings );
            that.fnDraw( false );
        }
 
        that.oApi._fnProcessingDisplay( oSettings, false );
 
        /* Callback user function - for event handlers etc */
        if ( typeof fnCallback == 'function' && fnCallback !== null )
        {
            fnCallback( oSettings );
        }
    }, oSettings );
};

function Desc_filter(qTYPE,logonUsername,pTYPE) {
        str_to_enc = 'query=' + qTYPE +
                        '&logonUsername=' + logonUsername +
                        '&type=' + pTYPE +
                        "&username=" +
                        "&password=" +
                        "&comment=" +
                        "&url=" +
			"&acl=<?php echo $groupIDStr ?>";
	//var enc_str = mcrypt.Encrypt(str_to_enc, "", "<?php echo $sess_id ?>", "rijndael-256", "cbc");
	var enc_str = btoa(CryptoJS.AES.encrypt(JSON.stringify(str_to_enc), "<?php echo $sess_id ?>", {format: CryptoJSAesJson}).toString());
        param_str = enc_str;
	$.ajaxSetup ({
	// Disable caching of AJAX responses
		cache: false
	});
	$.ajax
	({
		url: 'api.php',                  //the script to call to get data
		dataType: 'json',                //data format
		data: "param=" + param_str ,
		success: function(rows)          //on recieve of reply
		{
			var EVT_desc_str = "";
			for (i=0;i<rows.aaData.length;i++) {
				var desc_str = rows.aaData[i].evt_desc ;
				$("#desc_filter").append('<li><a onclick="BuildMainPwdTable(\''+ desc_str +'\',\'' + logonUsername + '\',\'\');">'+desc_str+'</a></li>');
			}
		}
	});

}

function resizeBtn(){
        var daterangebtn_width = $("#daterange").parent().width();
        var filterbtn_width = $("#btn-filter").parent().width();
        $("#daterange").css("width-min",'210px');
        $("#daterange").css("width",daterangebtn_width+'px');

        $("#btn-filter").css("width-min",'70px');
        $("#btn-filter").css("width",filterbtn_width+'px');
}

function BuildMainPwdTable(qTYPE,logonUsername,pTYPE)
{
	resizeBtn();	

	str_to_enc = 'query=' + qTYPE + 
			'&logonUsername=' + logonUsername + 
			'&type=' + pTYPE +
                        "&username=" +
                        "&password=" +
                        "&comment=" +
                        "&url=" +
			"&acl=<?php echo $groupIDStr ?>";
	var enc_str = btoa(CryptoJS.AES.encrypt(JSON.stringify(str_to_enc), "<?php echo $sess_id ?>", {format: CryptoJSAesJson}).toString());
	param_str = enc_str;

	var calcDataTableHeight = function() {
		return $(window).height()-250;
	};

	$(window).resize(function () {
		var oSettings = oTable.fnSettings();
		oSettings.oScroll.sY = calcDataTableHeight(); 
		oTable.fnAdjustColumnSizing();
		oTable.fnDraw();
		resizeBtn();
	});  

	if(oTable != null) {
		oTable.fnClearTable();
		oTable.fnAddData(datas_for_table);
	}
	else {             
		var oTable = $('#dataTables').dataTable( {
		"bDestroy": true,
		"aaSorting" : [[0, 'desc']],
		"sAjaxSource": 'api.php?param=' + param_str ,
		"aoColumns": [
		    { "mData": "evt_date", "sClass": "datatables_action" },
		    { "mData": "evt_recordid", "bVisible": false, "sClass": "datatables_action" },
		    { "mData": "evt_id", "sClass": "datatables_action" },
		    { "mData": "evt_desc", "sClass": "datatables_action" },
		    { "mData": "evt_sourceDC", "sClass": "datatables_action"},
		    { "mData": "evt_domain", "sClass": "datatables_action" },
		    { "mData": "evt_chg", "sClass": "datatables_action" },
		    { "mData": "evt_modby", "sClass": "datatables_action" },
		    { "mData": "id", "bVisible": false, "sClass": "datatables_action" }
		],
		deferRender: true,
		dom:         "rtiS",
		scrollY:     $(window).height()-250,
		scrollCollapse: true
		} );
	} 


	$.fn.dataTableExt.afnFiltering.push(
		function(oSettings, aData, iDataIndex) {
			if (aData[5] == audit_section_clicked){
				return true;
			}	
			else if (audit_section_clicked == "all") {
				return true;
			}
		}
	);

	$('li.navleft a').click(function() {
		audit_section_clicked = this.id;
		oTable.fnFilter( '' );	
		oTable.fnDraw();
	});

	$("#dataTables tbody").delegate("tr", "mouseenter mouseleave", function() {
		var iPos = oTable.fnGetPosition( this );
		if(iPos!=null){
			if ( $(this).hasClass('row_selected') ) {
			    $(this).removeClass('row_selected');
				evt_content = "";
				return evt_content;
			}
			else {
			    oTable.$('tr.row_selected').removeClass('row_selected');
			    $(this).addClass('row_selected');
				evt_content = 'Object modify by : ';
				evt_content += oTable.fnGetData( this )['evt_modby'];
				evt_content += '\n\n';
				evt_change_content = oTable.fnGetData( this )['evt_chg'].replace(/ (\w+ :)/g, '\n$1');
				var formatted_tooltip = evt_content + evt_change_content;
				this.setAttribute( 'title', formatted_tooltip);
			}
		}
	});
}

function getCSVData(){
	var csv_value=$('#dataTables').table2CSV({delivery:'ObjectDN'});
	$("#csv_dataTables").val(csv_value);
}

</script>
</head>
<body>
	<nav id="#mynav" class="navbar navbar-default navbar-fixed-top" role="navigation">
		<div class="navbar-header">
			<button type="button" class="navbar-toggle" data-toggle="collapse" data-target="#bs-example-navbar-collapse-1">
				<span class="sr-only">Toggle navigation</span>
				<span class="icon-bar"></span>
				<span class="icon-bar"></span>
				<span class="icon-bar"></span>
			</button>
			<div class="navbar-header navbar-left title">
				<h2>Active Directory Audit</h2>
			</div>
		</div>

		<div class="collapse navbar-collapse" id="bs-example-navbar-collapse-1">
			<ul class="nav navbar-nav navbar-right">
				<a id="btn_logoff" class="btn-marg btn btn-primary" href="index.php?logout=yes"><span class="fa fa-sign-out"></span></a>
			</ul>
		</div>
	</nav>


	<div id="my-nav" class="col-md-2 col-lg-2">
		<ul class="nav nav-pills nav-stacked affix" id="nav-menu">
			<li class="navleft active"><a id="all" data-toggle="tab">All</a></li>
			<?php
				foreach ($auditedDomains_arr as $auditedDomain) {
					echo "<li class='navleft'><a id='".$auditedDomain."' data-toggle='tab'>".$auditedDomain."</a></li>";
				}
			?>
			<div><br></div>
		</ul>
	</div>

	<div class="col-md-10 col-lg-10 main">
		<div id="dynamic" class="col-md-12 col-lg-12">
                        <div class="col-md-2 col-lg-2">
                                <form action="getCSV.php?tbl=csv_dataTables" method ="post" >
					<input type="hidden" name="csv_dataTables" id="csv_dataTables">
					<input class="btn btn-success pull-left" type="submit" value="Export to CSV" onclick="getCSVData()">
                                </form>	
			</div>
			<div class="col-md-10 col-lg-10">
				<div class="col-md-4 col-lg-4 div-content-right">
				<a id="daterange" class="btn-primary btn ">
					<i class="fa fa-calendar"></i>
					<span><?php echo date('M\ j, Y').' - '.date('M\ j, Y'); ?></span> <b class="caret"></b>
				</a>
				</div>
				<div class="btn-group col-md-2 col-lg-2 div-content-right">
				  <button type="button" id="btn-filter" class="btn btn-default dropdown-toggle" data-toggle="dropdown">
				      Filter   <span class="caret"></span>
				  </button>
				  <ul id="desc_filter" class="dropdown-menu" role="menu"></ul>
				</div>

				<div class="col-md-4 col-lg-4 div-content-right">
				<form role="form" class="input-group" >
					<input type="text" id="db_search" placeholder="Database Search " class="form-control" />
					<span class="input-group-btn">
						<a class="btn btn-default" onclick="BuildMainPwdTable($('#db_search').val(),username,'');">Submit</a>
					</span>
				</form>
				</div>
			</div><br><br><br>

			<table cellspacing="0" cellpadding="0" border="0" class="table table-striped table-bordered" id="dataTables">
				<thead><tr>
				    <th>Date</th>
				    <th>Record ID</th>
				    <th>Event</th>
				    <th>Description</th>
				    <th>Source DC</th>
				    <th>Domain</th>
				    <th>Change</th>
				    <th>Modify by</th>
				    <th>ID</th>
				</tr></thead>
				<tbody></tbody>
			</table>

			<script>
				var username = "<?php echo $username ?>";
				var d = new Date();
				var curr_date = d.getDate();
				var curr_month = ("0" + (d.getMonth() + 1)).slice(-2);
				var curr_year = d.getFullYear();
				daterange = '\'' + curr_year + "-" + curr_month + "-" + curr_date + ' 00:00:00\' AND \'' + curr_year + "-" + curr_month + "-" + curr_date + ' 23:59:59\'' ;
				BuildMainPwdTable(daterange,username,'');
				Desc_filter(2,username,'');
			</script>
		</div>
	</div>

</body>
</html>
